from trikk import Trikk
from passasjer import Passasjer


#Leser stopp fra en liste og putter disse inn i en liste
def lesStoppFraFil(filnavn):
    fil = open(filnavn)

    stopp = []
    for linje in fil:
        stopp.append(linje.strip())

    fil.close()

    return stopp

#leser inn passasjerer fra en fil og lage passasjer objekter som blir lagret i en liste
def lesInnPassjerer(filnavn):
    fil = open(filnavn)

    passasjerer = []
    for linje in fil:
        splitt = linje.strip().split(";")
        passasjer = Passasjer(splitt[0], splitt[1], splitt[2])
        passasjerer.append(passasjer)

    fil.close()

    return passasjerer

#Alle passasjere som skal på trikken går på trikken, hvis ikke den er full
def passasjererPaaTrikk(stoppet, passasjerer, trikk):
    for passasjer in passasjerer:
        if passasjer.hentPaastigning() == stoppet:
            komPaa = trikk.gaaPaaTrikk(passasjer) #en boolean
            if not komPaa:
                print("Trikken er full, kom ikke på")


#Kjører trikken en gang per stopp i listen stopp
def kjorTrikk(stopp, passasjerer, trikk):
    for stoppet in stopp:
        trikk.gaaAvTrikk(stoppet)
        passasjererPaaTrikk(stoppet, passasjerer, trikk)
        print("-------------", stoppet, "-----------")
        print(trikk)
        print("-------------------------------------")

#Skriver ut statestikk om passasjererene etter trikketuren
def statestikk(passasjerer):
    komPaa = 0
    komFram = 0
    lukter = 0
    ikkeFramPgaLukt = 0
    lengde = 0

    for passasjer in passasjerer:
        if passasjer.komPaa():
            komPaa += 1
        if passasjer.komFram():
            komFram += 1
        if passasjer.stinker():
            lukter += 1
        if passasjer.gikkAvPgaStank():
            ikkeFramPgaLukt += 1
        lengde += passasjer.hentAntallStasjoner()

    print("----------Informasjon om passasjerer----------")
    print("Antall som skulle ta trikken:", len(passasjerer))
    print("Antall som kom på trikken: ", komPaa)
    print("Antall som kom fram: ", komFram)
    print("Gjennomsnitts lengde paa tur:", lengde / len(passasjerer))
    print("Antall som lukter: ", lukter)
    print("Antall som ikke kom fram pga stank: ", ikkeFramPgaLukt)

def hovedprogram():
    trikk = Trikk(13, 10) #et objekt av type Trikk
    stopp = lesStoppFraFil("trikk13.txt")
    passasjerer = lesInnPassjerer("passasjerer.txt")
    kjorTrikk(stopp, passasjerer, trikk)
    statestikk(passasjerer)

hovedprogram()
